#ifdef __APPLE__
#import <AvailabilityMacros.h>
#else
#include <math.h>
#ifndef NAN
#define NAN FP_NAN
#endif
#endif

#import <Foundation/Foundation.h>

#import <stdio.h>
#import <math.h>

#import <pixel.h>
#import <material.h>
#import <list.h>

//---- @implementation section ----

@implementation link_t

- (id) init             { return [self init: nil: nil]; }
- (id) init: (id) _data { return [self init: _data: nil]; }
- (id) init: (id) _data: (link_t *) _next
{
  if(!(self = [super init]))
    return nil;
  data = _data;  next = _next;
  return self;
}

- (id)       data { return data; }
- (link_t *) next { return next; }

- (void) setnext: (link_t *) _next { next = _next; }
- (void) setdata: (id) _data { data = _data; }

@end

@implementation list_t

- (id) init
{
  if(!(self = [super init]))
    return nil;
  first = last = current = nil;
  return self;
}

- (id)   data { if(current != nil) return [current data]; }

- (id) pop
{
	link_t	*link = nil;
	id	_data;

  if(![self empty]) {
    link = first;
    _data = [first data];
    first = [first next];
    [self reset];
    [link release];
    return _data;
  }
  return nil;
}

- (void) add: (id) _data
{
	link_t	*link = [(link_t *)[link_t alloc] init: _data];

  if([self empty])
    first = last = link;
  else {
    [last setnext: link];
    last = link;
  }
}

- (void) reset { current = first; }
- (bool) empty { return first == nil ? true : false; }
- (bool) end   { return current == nil; }
- (void) next { current = [current next]; }

- (id)   getbyname: (NSString *)_name
{
  [self reset];
  while(![self end]) {
    if([[self data] matches: _name]) return [self data];
    [self next];
  }
  return nil;
}

- (void) write: (FILE *) _out
{
  [self reset];
  while(![self end]) {
    [[self data] write: _out];
    [self next];
  }
}

@end
