//---- @protocol section ----
@protocol searching
- (object_t *) find_closest: (vec_t *) pos: (vec_t *) dir:
                            (double *) dis:
                            (vec_t **) hit: (vec_t **) N;
@end

//---- @interface section ----

@interface model_t: NSObject <searching>	// Class: Parent
{
  camera_t *cam;
  list_t   *mats;
  list_t   *objs;
}

// + class methods

// - instance methods
  // constructors (overloaded)
- (id) init;

  // accessor/mutator
- (camera_t *) cam;
- (list_t *)   objs;
- (list_t *)   mats;
- (int)        getpw;
- (int)        getph;
- (double)     getww;
- (double)     getwh;

  // operators

  // members
- (void) read: (FILE *) _in;
- (void) write: (FILE *) _out;

@end

