#ifndef OBJ_COOKIE
#define OBJ_COOKIE 12345678
#endif

//---- @protocol section ----
@protocol intersecting
- (double) hits: (vec_t *) _pos: (vec_t *) _dir: (vec_t **) _hit: (vec_t **) _N;
@end

//---- @interface section ----
//@interface object_t: NSObject	// Class: Parent
@interface object_t: NSObject <intersecting>	// Class: Parent <protocol>
{
  int         cookie;
  NSString   *type;	// e.g., plane, sphere, etc.
  NSString   *name;	// e.g., left_wall, center_sphere, etc.

  material_t *mat;	// material

  vec_t      *last_hit;	// last hit point
  vec_t      *last_N;	// normal at last hit point
}

// + class methods

// - instance methods
  // constructors (overloaded)
- (id) init;

  // accessor/mutator
- (NSString *) settype: (NSString *)_type;
- (NSString *) setname: (NSString *)_name;
- (NSString *) getname;
- (NSString *) gettype;
- (material_t *) mat;
- (vec_t *)    getlast_hit;

  // operators

  // members
- (bool) matches: (NSString *) _name;
- (void) read: (FILE *) _in: (list_t *)mats;
- (void) write: (FILE *) _file;

@end
