#ifdef __APPLE__
#import <AvailabilityMacros.h>
#else
#include <math.h>
#ifndef NAN
#define NAN FP_NAN
#endif
#endif

#import <Foundation/Foundation.h>

#import <stdio.h>
#import <math.h>
#import <assert.h>
#import <string.h>

#import <vector.h>
#import <pixel.h>
#import <list.h>
#import <material.h>
#import <object.h>

//---- @implementation section ----

@implementation object_t

- (id) init
{
  if(!(self = [super init]))
    return nil;
  cookie = OBJ_COOKIE;
  name = [[NSString alloc] init];
  type = [[NSString alloc] init];
  mat = nil;
  last_hit = [[vec_t alloc] init];
  last_N = [[vec_t alloc] init];
  return self;
}

- (NSString *) settype: (NSString *) _type
{
  // release old obj but only after we retain new one (ok if name == _name)
  [type autorelease];
  type = [[_type copy] retain];
}

- (NSString *) setname: (NSString *) _name
{
  // release old obj but only after we retain new one (ok if name == _name)
  [name autorelease];
  name = [_name retain];
}

- (material_t *) mat { return mat; }
- (NSString *) gettype { return type; }
- (NSString *) getname { return name; }
- (vec_t *)    getlast_hit { return last_hit; }

  // operators

  // members
- (bool) matches: (NSString *) _name
{
  return [name isEqualToString: _name];
}

- (double) hits: (vec_t *) _pos: (vec_t *) _dir: (vec_t **) _hit: (vec_t **) _N
{
  fprintf(stderr,"in object_t: hits:_pos:_dir\n");

  return -1.0;
}

- (void) read: (FILE *) _in: (list_t *)mats
{
	char             c, _name[256];
	int              count;
	NSMutableString *str;

  // read descriptive name of object (e.g., left_wall, center_sphere, etc.
  assert((count = fscanf(_in,"%s",_name))==1);
  [self setname: [[NSString alloc] initWithUTF8String: _name]];

  // consume all chars until we get to '{'
  while((c=fgetc(_in)) != EOF && c != '{');

  // read in material (first attribute MUST be material)
  assert((count = fscanf(_in,"%s",_name))==1);
  if(!strcmp(_name,"material")) {
    assert((count = fscanf(_in,"%s",_name))==1);
    str = [[NSMutableString alloc] initWithUTF8String: _name];
    mat = [mats getbyname: str];
  }
  
  // consume whitespace
  while((c=fgetc(_in)) != EOF && c != '\n');
}

- (void) write: (FILE *) _out
{
  assert(cookie == OBJ_COOKIE);
 
  // output 'object' token and object name
  fprintf(_out,"%s %s\n",[type UTF8String],[name UTF8String]);
  fprintf(_out,"{\n");

  // output material
  fprintf(_out,"   %s %s\n","material",[[mat getname] UTF8String]);
}

@end
