#ifdef __APPLE__
#import <AvailabilityMacros.h>
#else
#include <math.h>
#ifndef NAN
#define NAN FP_NAN
#endif
#endif

#import <Foundation/Foundation.h>

#import <stdio.h>
#import <stdlib.h>
#import <assert.h>
#import <sys/time.h>

#import <timer.h>

//---- @implementation section ----

@implementation atimer_t

- (id) init { return [self init: 0.0: 0.0: 0.0]; }
- (id) init: (double) _ts: (double) _te: (double) _tt
{
  if(!(self = [super init]))
    return nil;
  ts = _ts;
  te = _te;
  tt = _tt;
  return self;
}

  // operators

  // members
- (void) start        { ts = [self stamp_us]; }
- (void) stop         { te = [self stamp_us]; tt = te - ts; }
- (double) elapsed_us { return tt; }
- (double) elapsed_ms { return tt/1000.0; }
- (double) elapsed_s  { return tt/1000000.0; }
- (double) stamp_us
{
	double		s,us,tod;
	struct timeval	tp;

  // get time of day (tod), return in microseconds
  gettimeofday(&tp,NULL);
  s = (double)(tp.tv_sec);   
  us = (double)(tp.tv_usec); 
  tod = s*1000000.0 + us;               
  return(tod);
}

@end
